config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
  # Almost every application defines a route for the root path ("/") at the top of this file.
  root 'home#index'
  post '/search', to: 'home#search'
  get '/clear_message', to: 'home#clear_message'

  resources :posts do
    resources :likes, only: %i[create destroy]
    resources :comments, only: %i[new create destroy]
  end

  get '/login', to: 'session#index', as: 'new_session'
  post '/login', to: 'session#create'
  delete '/logout', to: 'session#destroy', as: 'destroy_session'

  get '/register', to: 'registration#index', as: 'new_registration'
  post '/register', to: 'registration#create'
end

app/models/post.rb
# frozen_string_literal: true

# model Post
class Post < ApplicationRecord
  include PgSearch::Model

  belongs_to :user
  has_rich_text :content
  has_many :likes, dependent: :destroy
  has_many :comments, dependent: :destroy
  has_many :tags, dependent: :destroy

  accepts_nested_attributes_for :tags, allow_destroy: true

  after_create_commit { broadcast_append_to 'posts', self }
  after_update_commit { broadcast_replace_to 'posts', self }
  after_destroy_commit { broadcast_remove_to 'posts', self }

  validates :title, presence: true

  validates_presence_of :content

  pg_search_scope :pg_search, against: :title, using: { tsearch: { prefix: true } },
    associated_against: {
      tags: :name,
      user: :name,
    }
  
  def self.search(query)
    pg_search(query)
  end
end

app/controllers/posts_controller.rb
class PostsController < ApplicationController
  before_action :set_post, only: %i[ show edit update destroy ]

  # GET /posts or /posts.json
  def index
    @posts = Post.includes(:user, :tags, :comments).all
  end

  # GET /posts/1 or /posts/1.json
  def show; end

  # GET /posts/new
  def new
    @post = Post.new

    respond_to do |format|
      format.turbo_stream
      format.html { render :new }
    end
  end

  # GET /posts/1/edit
  def edit; end

  # POST /posts or /posts.json
  def create
    @post = Post.new(post_params)

    respond_to do |format|
      if @post.save
        format.html { redirect_to root_path, notice: t('post.messages.create') }
        format.json { render :show, status: :created, location: @post }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @post.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /posts/1 or /posts/1.json
  def update
    respond_to do |format|
      if @post.update(post_params)
        format.html { redirect_to @post, notice: t('post.messages.update') }
        format.json { render :show, status: :ok, location: @post }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @post.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /posts/1 or /posts/1.json
  def destroy
    @post.destroy
    respond_to do |format|
      format.html { redirect_to root_url, notice: t('post.messages.destroy') }
      format.json { head :no_content }
    end
  end

  private
  # Use callbacks to share common setup or constraints between actions.
  def set_post
    @post = Post.find(params[:id])
  end

  # Only allow a list of trusted parameters through.
  def post_params
    params.require(:post).permit(:title, :content, :user_id, tags_attributes: %i[id name _destroy])
  end
end

app/helpers/posts_helper.rb
module PostsHelper
  def liked?(post)
    post.likes.where(user_id: current_user.id).present?
  end
end

app/views/posts/_form.html.erb
<%= form_with(
  model: post,
  html: {
    data: { 
      controller: 'form', 
      action: 'submit->form#clear',
    },
    class: 'mx-10 border-b shadow-lg px-10'
  }) do |form| %>
  <% if post.errors.any? %>
    <div class="w-full p-2 border border-red-500 rounded-md mt-5">
      <h2 class="font-bold"><%= t('errors.template.header.other', model: post.model_name ,count: post.errors.count) %></h2>

      <ul>
        <% post.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="my-5" data-controller="tag-list" data-tag-list-list-value="<%= post.tags.pluck(:name) %>">
      
    <h1>Tags:</h1>
    <div class="flex flex-wrap w-full p-2 border-gray-400 shadow-md mb-5 rounded-md align-items-center" data-tag-list-target="tagList">
        <div class="flex flex-wrap gap-2">
        <%= form.fields_for :tags do |tag| %>
            <span class="flex flex-wrap font-bold normal-case p-1 bg-green-500 rounded-md text-white">
              <%= tag.hidden_field :id %>
              <%= tag.label :name, class: 'm-2 form-label text-white normal-case', value: tag.object.name %>
              <%= tag.check_box :_destroy, class: 'h-4 w-4 ml-2 self-center p-2 border-gray-200', data: { action: 'change->tag-list#remove'} %>
              <span class="ml-1 text-xs self-center">Excluir?</span>
            </span>
        <% end %>
       </div>
    </div>
    <label class="form-label">Adicione tags</label>
    <input 
      type="text"
      class="form-control"
      data-tag-list-target="tagInput"
      placeholder="Adicione tags separadao por virgula"      
    >
    <button type="button" class="btn-primary p-1 my-2" data-action="click->tag-list#change">Adicionar tag</button>
  </div>

  <div class="my-5">
    <%= form.label :title, class: 'form-label' %>
    <%= form.text_field :title, class: 'form-control' %>
  </div>

  <div class="my-5">
    <%= form.hidden_field :user_id, value: current_user.id %>
  </div>

  <div class="my-5">
    <%= form.label :content, class: 'form-label' %>
    <%= form.rich_text_area :content, class: 'form-control' %>
  </div>

  <div class="my-5 flex items-center justify-between">
    <%= form.submit class: 'btn-primary' %>
    <%= link_to "Voltar", root_path, class: 'btn-primary bg-red-500 hover:bg-red-700', 'data-turbo-frame': '_top' %>
  </div>
<% end %>

app/views/posts/_post.html.erb
<%= turbo_stream_from post %>
<%= turbo_frame_tag dom_id(post) do %>
  <div class="w-12/12 p-5 border-b shadow-md mt-3 rounded-md">
    <h1 class="text-3xl text-gray-500">
      <%= post.title %>
    </h1>

    <p class="text-gray-400 mb-5">
      <strong class="text-gray-400">Author:</strong>
      <%= post.user.name %>
      <strong class="text-gray-400 ml-4">Published:</strong>
      <%= post.created_at.strftime('%d/%m/%Y') %>
      <strong class="text-gray-400 ml-4">Tags:</strong>
      <%= post.tags.pluck(:name).join(', ') %>
    </p>

    <%= post.content %>

    <div class="w-full flex items-center justify-between">
      <%= link_to "Continue lendo post", post, class: 'underline text-gray-600', 'data-turbo-frame': '_top' %>
      <p class="font-bold text-gray-600">Curtidas <%= post.likes.size %></p>
      <p class="font-bold text-gray-600">Comentários <%= post.comments.size %></p>

      <% if user_signed_in? %>
        <% if liked?(post)  %>
          <%= button_to "Dislike",
            post_like_path(post, current_user),
            data: { controller: 'form', action: 'form#clear', 'turbo-frame': '_self'},
            method: :delete,
            class: 'btn-danger p-2'
          %>
        <% else %>
          <%= button_to "Like",
            post_likes_path(post),
            class: 'btn-success',
            data: { controller: 'form', action: 'form#clear', 'turbo-frame': '_self'}
          %>
        <% end %>
      <% end %>
    </div>
  </div>
<% end %>

app/views/posts/edit.html.erb
<%= turbo_frame_tag dom_id(@post) do %>
  <div class="w-full mx-auto">
    <h1 class="text-3xl text-center font-bold text-gray-500">Editar Post</h1>
  </div>
  <div class="w-full p-5 border-b shadow-md">
   <%= render "form", post: @post %>
  </div>
<% end %>

app/views/posts/index.html.erb
<%= turbo_frame_tag :posts do %>
  

  <% unless @posts.present? %>
    <div class="w-full justify-center">
      <h1 class="font-bold text-4xl text-gray-400 mt-10 text-center w-full inline-block">
        Nenhum post cadastrado !
      </h1>

      <% if user_signed_in? %>
        <%= link_to 'Criar post', new_post_path, class: 'mx-auto mt-10 p-2 bg-blue-700 text-white text-center rounded-md block w-2/12', 'data-turbo-frame': '_top' %>
      <% end %>
    </div>
  <% end %>

  <% unless user_signed_in? %>
    <p class="font-4xl text-center text-lg tex-gray-500 mt-5">
      Faça 
      <%= link_to 'login', login_path, class: 'font-bold text-lg text-blue-500 underline', 'data-turbo-frame': '_top' %> 
      ou 
      <%= link_to 'registre-se', new_registration_path, class: 'font-bold text-lg text-green-500 underline', 'data-turbo-frame': '_top' %> 
      para criar um post.
    </p>
  <% end %>

  <div class="w-full">
    <%= render @posts %>
  </div>

<% end %>

app/views/posts/new.html.erb
<div class="bg-white border shadow-md rounded-md pb-12 w-4/3 mx-auto pt-5">
  <h1 class="text-4xl text-gray-400 text-center">Novo Post</h1>

  <%= render "form", post: @post %>

</div>

app/views/posts/show.html.erb
<%= turbo_frame_tag dom_id(@post) do %>
  <% if notice %>
    <%= turbo_frame_tag :notice do %>
      <%= notice_stream(message: notice, status: :info) %>
    <% end %>
  <% end %>

  <div class="bg-white border shadow-md rounded-md pb-12 w-4/3 mx-auto p-5">
    <div class="flex items-center justify-between">
      <%= link_to "Home", 
        root_path,
        class: 'btn-primary px-5 mb-5',
        'data-turbo-frame': '_top'
      %>

      <% if user_signed_in? && current_user.id == @post.user_id %>
        <%= link_to "Editar", edit_post_path(@post), class: 'btn-success px-5 mb-5' %>
        <%= button_to "Remover", 
          post_path(@post),
          class: 'btn-danger px-5 mb-4',
          method: :delete,
          'data-turbo-frame': '_top',
          data: { controller: 'confirm', confirm_message_value: t('messages.delete'), action: 'click->confirm#destroy'}
        %>
      <% end %>
    </div>

    <h1 class="text-3xl text-gray-500">
      <%= @post.title %>
    </h1>

    <p class="text-gray-600 mb-5">
      <strong class="text-gray-500">Author:</strong>
      <%= @post.user.name %>
      <strong class="text-gray-400 ml-4">Criado em:</strong>
      <%= @post.created_at.strftime('%d/%m/%Y') %>
      <strong class="text-gray-400 ml-4">Tags:</strong>
      <%= @post.tags.pluck(:name).join(', ') %>
    </p>

    <%= @post.content %>

    <div class="mt-5 mb-2s">
      <span class="text-gray-500">Likes <%= @post.likes.size %></span>
    </div>

      <div class="border-t border-gray-300 w-full mt-5">
        <%= turbo_frame_tag :total_comments do %>
          <h1 class="text-4xl text-gray-600 p-2 mt-5"><%= @post.comments.size %> Comentários </h1>
        <% end %>

        <%= turbo_frame_tag :notice_comment %>

        <%= turbo_frame_tag :comments do %>
          <%= render @post.comments %>
        <% end %>
      </div>

    <% if user_signed_in? %>
      <div class="w-full my-5">
        <%= link_to  'Criar comentário' , new_post_comment_path(@post) , class: 'btn-primary', 'data-turbo-frame': 'new_comment' %>

        <%= turbo_frame_tag :new_comment %>
      </div>
    <% else %>
      <div class="w-full my-5">
        <p class="font-4xl text-center text-lg tex-gray-500 mt-5">
          Faça 
          <%= link_to 'login', login_path, class: 'font-bold text-lg text-blue-500 underline', 'data-turbo-frame': '_top' %> 
          ou 
          <%= link_to 'registre-se', new_registration_path, class: 'font-bold text-lg text-green-500 underline', 'data-turbo-frame': '_top' %> 
          para criar um comentário.
        </p>
      </div>
    <% end %>
  </div>
<% end %>